package com.z.toys.dns.provider;

import com.z.toys.dns.model.ParamModel;

/**
 * @author wangzz
 * @since 2024/3/26
 **/
public interface DnsProvider {

    String ALIYUN = "aliyun";

    /**
     * 打印域名信息
     * @param param
     * @author wangzz
     * @since 2024/3/26
     */
    void printDomainInfo(ParamModel param);

    /**
     * 添加域名
     * @param param
     * @author wangzz
     * @since 2024/3/26
     */
    void addDomain(ParamModel param);

    /**
     * 更新域名
     * @param param
     * @author wangzz
     * @since 2024/3/26
     */
    void updateDomain(ParamModel param);

    /**
     * 删除域名
     * @param param
     * @author wangzz
     * @since 2024/3/26
     */
    void deleteDomain(ParamModel param);

}
